/*******************************************************************************
 *	BdsDataFileAscii.h	Data File Access
 *			T.Barnaby,	BEAM Ltd,	2008-06-24
 *******************************************************************************
 */
#ifndef BdsDataFileAscii_H
#define	BdsDataFileAscii_H

#include <BdsDataFile.h>
#include <BdsD.h>

namespace Bds {

class DataFileAscii : public DataFile {
public:
				DataFileAscii();

	BError			open(BString fileName, BString mode);

	DataOrder		getDataOrder();
	int			getFeatures();
	
	BError			setFormat(BString format);
	BError			setInfo(DataInfo& dataInfo, ChannelInfos& channelInfos);
	BError			start(BUInt channel, BUInt segment);
	BError			writeData(DataBlock& data);
	BError			end();

	static DataFormat	getFormats();

private:
	DataInfo		odataInfo;
	ChannelInfos		ochannelInfos;
	BString			oformat;
};

}
#endif
