/*******************************************************************************
 *	BdsDataFileBdrs.h	BDRS Data File Access
 *			T.Barnaby,	BEAM Ltd,	2008-06-24
 *******************************************************************************
 */
#ifndef BdsDataFileBdrs_H
#define	BdsDataFileBdrs_H

#include <BdsDataFile.h>

namespace Bds {

class DataFileBdrs : public DataFile{
public:
				DataFileBdrs();

	int			getFeatures();						///< Get bitmask of supported features
	DataOrder		getDataOrder();

	BError			getInfo(DataInfo& dataInfo, Options options, BList<BError>& errors);
	BError			readData(BUInt32 channel, BUInt segment, BUInt32 blockNumber, DataBlock& data);

	static DataFormat	getFormats();
private:
	BError			readBlock(BUInt32 channel, BUInt64 pos, DataBlock& data);

	int			omagic;
	int			oyear;
	int			oblockYear;
	BUInt32			oblockSize;
	double			osampleRate;
	DataInfo		odataInfo;
	BArray<DataBlockPos>	oblockPositions;
};

}
#endif
