/*******************************************************************************
 *	BdsLib.h	Data File Access
 *			T.Barnaby,	BEAM Ltd,	2008-12-03
 *******************************************************************************
 */
#ifndef BdsLib_H
#define	BdsLib_H

#include <BdsD.h>
#include <BString.h>

namespace Bds {

/// Response Editor object
class ResponseEdit : public Response {
public:
			ResponseEdit(const Response& response);
			~ResponseEdit();
	
	BString		getString();
	void		setString(BString str);
};


// Bds Channel name manipulations
void	bdsChannelGetTypeAux(BString name, BString& type, BString& aux);
BString	bdsChannelGetName(BString type, BString aux);

// Bds Data Meta data manipulations
BError	bdsDataInfoSetTimeRange(DataInfo& dataInfo);
BError	bdsDataInfoFromInfo(BDictString info, DataInfo& dataInfo);
BError	bdsInfoFromDataInfo(DataInfo& dataInfo, BDictString& info);
BString bdsStationAlias(Station station);
BString	bdsDataChannelInfo(DataChannel& dataChannel);
BString	bdsDataChannelRef(DataChannel& dataChannel);
BString	bdsSelectionChannelInfo(Selection& selection, BUInt channel);

// Calculations
double	bdsPoleZeroGain(const PoleZero& poleZero, double frequency);		///< Claculates the overal gain of the given PoleZero transfer function

// Bds Debug functions
void	bdsDumpSelection(Selection sel);
void	bdsDumpDataInfo(DataInfo dataInfo);
void	bdsDumpPoleZeros(PoleZero poleZeros);

}
#endif
