/*******************************************************************************
 *	BConfig.h	Config File Access
 *			T.Barnaby,	BEAM Ltd,	2009-01-28
 *******************************************************************************
 */
#ifndef BConfig_H
#define	BConfig_H

#include <BDict.h>
#include <BFile.h>
#include <BMutex.h>

/// This class implements the configuration file access
class BConfig : public BDictString {
public:
	BError		open(BString fileName, BString mode = "r");
	BError		read();
	BError		write();
	
	BString		findValue(BString name);
private:
	BMutex		olock;
	BFile		ofile;
};
#endif
