/*******************************************************************************
 *	BEndian.h	Byte swap fubctions
 *			T.Barnaby,	BEAM Ltd,	2009-12-18
 *******************************************************************************
 */
#ifndef BEndian_H
#define BEndian_H	1

#include <byteswap.h>
#include <BTypes.h>

inline void bswap_p8(const void* s, void* d){
	const char*	sp = (const char*)s;
	char*		dp = (char*)d;

	*dp = *sp;
}

inline void bswap_p16(const void* s, void* d){
	const char*	sp = (const char*)s;
	char*		dp = (char*)d;

	dp[1] = sp[0];
	dp[0] = sp[1];
}

inline void bswap_p32(const void* s, void* d){
	const char*	sp = (const char*)s;
	char*		dp = (char*)d;

	dp[3] = sp[0];
	dp[2] = sp[1];
	dp[1] = sp[2];
	dp[0] = sp[3];
}

inline void bswap_p64(const void* s, void* d){
	const char*	sp = (const char*)s;
	char*		dp = (char*)d;

	dp[7] = sp[0];
	dp[6] = sp[1];
	dp[5] = sp[2];
	dp[4] = sp[3];
	dp[3] = sp[4];
	dp[2] = sp[5];
	dp[1] = sp[6];
	dp[0] = sp[7];
}

void bswap_copy(int swap, const void* src, void* dst, BUInt32 nBytes, const char* swapType);

#endif
